package org.ajc.system;

import java.io.File;

import org.ajc.core.AjcCore;
import org.apache.commons.configuration.PropertiesConfiguration;

import protoj.lang.StandardProject;

// AjcCore compiles and invokes this main class.
public final class AjcProject {
	public static void main(String[] args) {
		AjcCore core = new AjcCore(args);
		StandardProject project = core.getProject();

		// ${var} variables in ivy.xml will get replaced with these
		PropertiesConfiguration replacements = new PropertiesConfiguration();
		replacements.addProperty("alien.version", "1.0");
		replacements.addProperty("junit.version", "4.4");
		project.getResourceFeature().initReplacements(replacements);

		// the specified ivy.xml file will be use for downloading dependencies
		project.getRetrieveFeature().initConfig("/ajc/ivy.xml", null, null);

		// the specified amount of memory can be allocated by junit
		project.initJunit("16m");

		// the specified project archives can be created
		project.getArchiveFeature().initProjectArchive("ajc", "ajc");
		project.getArchiveFeature().addClasses("ajc");
		project.getArchiveFeature().addSources("ajc");
		project.getArchiveFeature().addJavadoc("ajc", "16m");

		// an additional project specific command
		project.getCommandStore().addCommand("hello-ajc",
				"writes to the console", "16m", new Runnable() {
					public void run() {
						System.out.println("hello from this sample project!");
					}
				});

		// process the commands captured from the command line
		project.getDispatchFeature().dispatchCommands();
	}

	private void unused() {
		// the SoftException aspect should ensure no throws clause is needed and
		// therefore compile time weaving is working
		new File(".").getCanonicalPath();
	}
}
