package org.basic.core;

import protoj.core.ArgRunnable;
import protoj.core.CompileFeature;
import protoj.lang.StandardProject;

// basic shell script invokes this main class.
public final class BasicCore {
	public static void main(String[] args) {
		BasicCore core = new BasicCore(args);

		// process the commands captured from the command line
		core.dispatchCommands();
	}

	private StandardProject project;

	public BasicCore(String[] args) {
		project = new StandardProject(args, "basic Version 1.0");

		// the ajc compiler is used to compile the entire project
		project.getCompileFeature().initConfig(false,
				new ArgRunnable<CompileFeature>() {
					public void run(CompileFeature feature) {
						feature.getJavacCompileTask().getCompileTask()
								.setMemoryMaximumSize("16m");
						feature.getJavacCompileTask().getCompileTask()
								.setSource("1.5");
					}
				});

		// a new vm is used to run all commands with the specified main class
		project.getDispatchFeature().initBootstrap(
				"org.basic.system.BasicProject", "16m");
	}

	public StandardProject getProject() {
		return project;
	}

	public void dispatchCommands() {
		getProject().getDispatchFeature().dispatchCommands();
	}

}
