package org.basic.system;

import org.apache.commons.configuration.PropertiesConfiguration;
import org.basic.core.BasicCore;

import protoj.lang.StandardProject;

// BasicCore compiles and invokes this main class.
public final class BasicProject {
	public static void main(String[] args) {
		BasicCore core = new BasicCore(args);
		StandardProject project = core.getProject();

		// ${var} variables in ivy.xml will get replaced with these
		PropertiesConfiguration replacements = new PropertiesConfiguration();
		replacements.addProperty("alien.version", "1.0");
		replacements.addProperty("junit.version", "4.4");
		project.getResourceFeature().initReplacements(replacements);

		// the specified ivy.xml file will be use for downloading dependencies
		project.getRetrieveFeature().initConfig("/basic/ivy.xml", null, null);

		// the specified amount of memory can be allocated by junit
		project.initJunit("16m");

		// the specified project archives can be created
		project.getArchiveFeature().initProjectArchive("basic", "basic");
		project.getArchiveFeature().addClasses("basic");
		project.getArchiveFeature().addSources("basic");
		project.getArchiveFeature().addJavadoc("basic", "16m");

		// an additional project specific command
		project.getCommandStore().addCommand("hello-basic",
				"writes to the console", "16m", new Runnable() {
					public void run() {
						System.out.println("hello from this sample project!");
					}
				});
		project.getDispatchFeature().dispatchCommands();
	}
}
